import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.*;
import java.awt.event.*;

public class Square extends JFrame
{
   public static final long serialVersionUID = 1L; // gets rid of an annoying warning

   // Default constructor.
   public Square()
   {
      super( "Square" );

      Container c = getContentPane();

      // Create a PaintPanel instance for drawing on.
      PaintPanel p = new PaintPanel();

      // Place the drawing panel in the frame.
      c.add(p);

      setSize(500, 500);
      setVisible(true);
   }


   public static void main( String args[] )
   {
      Square app = new Square();

      app.addWindowListener(
         new WindowAdapter()
         {  public void windowClosing( WindowEvent e )
            {  System.exit( 0 );
            }
         });
   }//main()

}//Square



// PaintPanel draws the image
class PaintPanel extends JPanel
{
   public static final long serialVersionUID = 1L; // gets rid of an annoying warning

   int x1, y1, x2, y2;

   public PaintPanel()
   {
      repaint();
   }

   // Tell the panel how to draw things
   public void paintComponent(Graphics g)
   {
      // It's necessary to invoke this method to clear the viewing area.
      super.paintComponent(g);

      draw(g);
   }//paint()

   public void draw(Graphics g)
   {

      int[] poly_x = { 100, 400, 400, 100 };
      int[] poly_y = { 100, 100, 400, 400 };

      g.setColor(Color.black);
      g.fillPolygon(poly_x, poly_y, 4);

   }//draw()

}//PaintPanel