/*
   To compile and link with gcc use the command
      gcc -Wall -g -o simple.exe  simple.c -lopengl32 -lglu32 -lglut32
   You will need to have the glut32.dll file in the
   same directory as your source file.
*/

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif


/* Prototype for the display callback function */
void display( void );


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);    /* 500 x 500 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow("Primitives-v2"); /* window title */
   glutDisplayFunc(display);       /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   /* attributes */
   glShadeModel(GL_FLAT);            /* also try glShadeModel(GL_SMOOTH) */
   glPolygonMode(GL_BACK, GL_LINE);
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-1.0, 1.0, -1.0, 1.0); /* viewing volume */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT);  /* clear the window */

   /* Use just ONE of the following glBegin() functions */
   //glBegin(GL_POINTS);
   //glBegin(GL_LINES);
   //glBegin(GL_LINE_STRIP);
   //glBegin(GL_LINE_LOOP);
   //glBegin(GL_TRIANGLES);
   //glBegin(GL_TRIANGLE_STRIP);
   glBegin(GL_TRIANGLE_FAN);
   //glBegin(GL_QUADS);
   //glBegin(GL_QUAD_STRIP);
   //glBegin(GL_POLYGON);
      glVertex2f( 1.0,    0.0);  /* 8 points evenly spaced around the unit circle */
      glVertex2f( 0.705,  0.705);
      glVertex2f( 0.0,    1.0);
         glColor3f(0.0, 1.0, 0.0);
      glVertex2f(-0.705,  0.705);
         glColor3f(0.0, 0.0, 1.0);
      glVertex2f(-1.0,    0.0);
         glColor3f(1.0, 1.0, 0.0);
      glVertex2f(-0.705, -0.705);
         glColor3f(0.0, 1.0, 1.0);
      glVertex2f( 0.0,   -1.0);
         glColor3f(1.0, 0.0, 0.0);
      glVertex2f( 0.705, -0.705);
   glEnd();

   glFlush(); /* clear buffers */
}//display()

/*

Here is how eight evenly spaced points around the unit circle are computed.

[cos(2*Pi*n/8), sin(2*Pi*n/8)], n=0..7

[cos(0),      sin(0)]      = [1, 0]                       = [1.0,    0.0]
[cos(1/4*Pi), sin(1/4*Pi)] = [1/2*2^(1/2), 1/2*2^(1/2)]   = [0.705,  0.705]
[cos(1/2*Pi), sin(1/2*Pi)] = [0, 1]                       = [0.0,    1.0]
[cos(3/4*Pi), sin(3/4*Pi)] = [-1/2*2^(1/2), 1/2*2^(1/2)]  = [-0.705, 0.705]
[cos(Pi),     sin(Pi)]     = [-1, 0]                      = [-1.0,   0.0]
[cos(5/4*Pi), sin(5/4*Pi)] = [-1/2*2^(1/2), -1/2*2^(1/2)] = [-0.705, -0.705]
[cos(3/2*Pi), sin(3/2*Pi)] = [0, -1]                      = [0.0,    -1.0]
[cos(7/4*Pi), sin(7/4*Pi)] = [1/2*2^(1/2), -1/2*2^(1/2)]  = [0.705,  -0.705]

*/